%-- This code has been realized to illustrate neural network concepts during 
%-- the workshop organized by the "club EEA" which happened in March 2018 
%-- https://rnn2018lyon.sciencesconf.org/
%--
%-- This code has been strongly inspired by the Mooc of Andrew Ng on coursera
%-- https://www.coursera.org/learn/machine-learning/
%-- 
%-- The application treated here concerns the automatic recognition of 
%-- digits drawn by hand. This code is not protected by any license, you 
%-- can re-use it freely without any restriction. Please do not forget to
%-- cite this event for any use of the code.

function [p,prob] = predict(Theta1, Theta2, X)

    %-- PREDICT Predict the label for a neural network classifiers. The labels 
    %-- are in the range 1..10. 
    %-- p = PREDICT(Theta1, Theta2, X) outputs the predicted label of X 
    %-- given the trained weights of a neural network (Theta1, Theta2). 
    %-- Note that X contains the examples in rows.


    % Useful values
    m = size(X, 1);

    % You need to return the following variables correctly 
    p = zeros(size(X, 1), 1);

    %-- Compute activation matrices
    a1 = [ones(m, 1) X];
    a2 = nn.sigmoid(Theta1*a1')';
    a2 = [ones(m, 1) a2];
    a3 = nn.sigmoid(Theta2*a2')';
    [val,p] = max(a3,[],2);   %-- compute the max for each row.
    prob = round(val*1000)/10;
    
    %-- the digit 0 is identified as label 10
    if (p==10)
        p=0;
    end

end
