%-- This code has been realized to illustrate neural network concepts during 
%-- the workshop organized by the "club EEA" which happened in March 2018 
%-- https://rnn2018lyon.sciencesconf.org/
%--
%-- This code has been strongly inspired by the Mooc of Andrew Ng on coursera
%-- https://www.coursera.org/learn/machine-learning/
%-- 
%-- The application treated here concerns the automatic recognition of 
%-- digits drawn by hand. This code is not protected by any license, you 
%-- can re-use it freely without any restriction. Please do not forget to
%-- cite this event for any use of the code.

function updateCanevas()

    %-- Global parameter for the GUI application
    global imgCanevas;
    
    %-- Get the mouse pointer position
    C = get(gca,'CurrentPoint');
    pad = 5;
    if ( (C(1,1)<pad) || (C(1,1)>(180-pad)) || (C(1,2)<pad) || (C(1,2)>(180-pad)) )
        return
    end

    %-- Set a [15x15] square region centered to the mouse pointer to 1 
    %-- on the global parameter imgCanevas 
    i = round(C(1,2));
    j = round(C(1,1));
    imgCanevas(i-4:i+4,j-4:j+4) = 1;
    
    %-- Update the display of the canvas
    h1 = subplot(1,2,1); cla(h1);    
    subplot(1,2,1); imagesc(imgCanevas); axis image; colormap(gray); 
    title({'Draw a digit here','Press c to clear || v to display info'}); 
    caxis([0 1]); axis off;
    
end
